﻿using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Threading;

namespace TestServer
{
    /// <summary>
    /// 단순 서비스
    /// </summary>
    [ServiceBehavior(ConcurrencyMode = ConcurrencyMode.Single, InstanceContextMode = InstanceContextMode.PerSession)]
    public class SimpleService : ISimpleService
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 짝수 번호 리스트 구하기 - GetEvenNumberList()

        /// <summary>
        /// 짝수 번호 리스트 구하기
        /// </summary>
        /// <returns>짝수 번호 리스트</returns>
        public List<int> GetEvenNumberList()
        {
            Console.WriteLine("[{0}] 짝수 번호 리스트 구하기 스레드 {1}가 시작되었습니다.", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), Thread.CurrentThread.ManagedThreadId);

            List<int> listEvenNumberList = new List<int>();

            for(int i = 0; i <= 10; i++)
            {
                Thread.Sleep(200);

                if(i % 2 == 0)
                {
                    listEvenNumberList.Add(i);
                }
            }

            Console.WriteLine("[{0}] 짝수 번호 리스트 구하기 스레드 {1}가 완료되었습니다.", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), Thread.CurrentThread.ManagedThreadId);

            return listEvenNumberList;
        }

        #endregion
        #region 홀수 번호 리스트 구하기 - GetOddNumberList()

        /// <summary>
        /// 홀수 번호 리스트 구하기
        /// </summary>
        /// <returns>홀수 번호 리스트</returns>
        public List<int> GetOddNumberList()
        {
            Console.WriteLine("[{0}] 홀수 번호 리스트 구하기 스레드 {1}가 시작되었습니다.", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), Thread.CurrentThread.ManagedThreadId);

            List<int> listOddNumberList = new List<int>();

            for(int i = 0; i <= 10; i++)
            {
                Thread.Sleep(200);

                if(i % 2 != 0)
                {
                    listOddNumberList.Add(i);
                }
            }

            Console.WriteLine("[{0}] 홀수 번호 리스트 구하기 스레드 {1}가 완료되었습니다.", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), Thread.CurrentThread.ManagedThreadId);

            return listOddNumberList;
        }

        #endregion
    }
}